/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         gradmparse
#define yylex           gradmlex
#define yyerror         gradmerror
#define yydebug         gradmdebug
#define yynerrs         gradmnerrs
#define yylval          gradmlval
#define yychar          gradmchar

/* First part of user prologue.  */
#line 1 "./gradm.y"

/*
 * Copyright (C) 2002-2014 Bradley Spengler, Open Source Security, Inc.
 *        http://www.grsecurity.net spender@grsecurity.net
 *
 * This file is part of gradm.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */


#include "gradm.h"

extern int gradmlex(void);

struct ip_acl ip;
struct var_object *var_obj = NULL;
char *nested[MAX_NEST_DEPTH];
int current_nest_depth = 0;

#line 110 "gradm.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "gradm.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_ROLE = 3,                       /* ROLE  */
  YYSYMBOL_ROLE_NAME = 4,                  /* ROLE_NAME  */
  YYSYMBOL_SUBJECT = 5,                    /* SUBJECT  */
  YYSYMBOL_SUBJ_NAME = 6,                  /* SUBJ_NAME  */
  YYSYMBOL_OBJ_NAME = 7,                   /* OBJ_NAME  */
  YYSYMBOL_HOSTNAME = 8,                   /* HOSTNAME  */
  YYSYMBOL_RES_NAME = 9,                   /* RES_NAME  */
  YYSYMBOL_RES_SOFTHARD = 10,              /* RES_SOFTHARD  */
  YYSYMBOL_CONNECT = 11,                   /* CONNECT  */
  YYSYMBOL_BIND = 12,                      /* BIND  */
  YYSYMBOL_IPTYPE = 13,                    /* IPTYPE  */
  YYSYMBOL_IPPROTO = 14,                   /* IPPROTO  */
  YYSYMBOL_CAP_NAME = 15,                  /* CAP_NAME  */
  YYSYMBOL_ROLE_ALLOW_IP = 16,             /* ROLE_ALLOW_IP  */
  YYSYMBOL_PAX_NAME = 17,                  /* PAX_NAME  */
  YYSYMBOL_ROLE_TRANSITION = 18,           /* ROLE_TRANSITION  */
  YYSYMBOL_VARIABLE = 19,                  /* VARIABLE  */
  YYSYMBOL_DEFINE = 20,                    /* DEFINE  */
  YYSYMBOL_DEFINE_NAME = 21,               /* DEFINE_NAME  */
  YYSYMBOL_DISABLED = 22,                  /* DISABLED  */
  YYSYMBOL_ID_NAME = 23,                   /* ID_NAME  */
  YYSYMBOL_USER_TRANS_ALLOW = 24,          /* USER_TRANS_ALLOW  */
  YYSYMBOL_GROUP_TRANS_ALLOW = 25,         /* GROUP_TRANS_ALLOW  */
  YYSYMBOL_USER_TRANS_DENY = 26,           /* USER_TRANS_DENY  */
  YYSYMBOL_GROUP_TRANS_DENY = 27,          /* GROUP_TRANS_DENY  */
  YYSYMBOL_DOMAIN_TYPE = 28,               /* DOMAIN_TYPE  */
  YYSYMBOL_DOMAIN = 29,                    /* DOMAIN  */
  YYSYMBOL_INTERFACE = 30,                 /* INTERFACE  */
  YYSYMBOL_IPOVERRIDE = 31,                /* IPOVERRIDE  */
  YYSYMBOL_REPLACE = 32,                   /* REPLACE  */
  YYSYMBOL_REP_ARG = 33,                   /* REP_ARG  */
  YYSYMBOL_AUDIT = 34,                     /* AUDIT  */
  YYSYMBOL_SOCKALLOWFAMILY = 35,           /* SOCKALLOWFAMILY  */
  YYSYMBOL_SOCKFAMILY = 36,                /* SOCKFAMILY  */
  YYSYMBOL_ROLE_UMASK = 37,                /* ROLE_UMASK  */
  YYSYMBOL_OBJ_MODE = 38,                  /* OBJ_MODE  */
  YYSYMBOL_SUBJ_MODE = 39,                 /* SUBJ_MODE  */
  YYSYMBOL_IPADDR = 40,                    /* IPADDR  */
  YYSYMBOL_IPNETMASK = 41,                 /* IPNETMASK  */
  YYSYMBOL_NOT = 42,                       /* NOT  */
  YYSYMBOL_IPPORT = 43,                    /* IPPORT  */
  YYSYMBOL_ROLE_TYPE = 44,                 /* ROLE_TYPE  */
  YYSYMBOL_UMASK = 45,                     /* UMASK  */
  YYSYMBOL_46_ = 46,                       /* '&'  */
  YYSYMBOL_47_ = 47,                       /* '|'  */
  YYSYMBOL_48_ = 48,                       /* '-'  */
  YYSYMBOL_49_ = 49,                       /* '('  */
  YYSYMBOL_50_ = 50,                       /* ')'  */
  YYSYMBOL_51_ = 51,                       /* '{'  */
  YYSYMBOL_52_ = 52,                       /* '}'  */
  YYSYMBOL_53_ = 53,                       /* ':'  */
  YYSYMBOL_54_ = 54,                       /* '/'  */
  YYSYMBOL_YYACCEPT = 55,                  /* $accept  */
  YYSYMBOL_compiled_acl = 56,              /* compiled_acl  */
  YYSYMBOL_various_acls = 57,              /* various_acls  */
  YYSYMBOL_replace_rule = 58,              /* replace_rule  */
  YYSYMBOL_variable_expression = 59,       /* variable_expression  */
  YYSYMBOL_variable_object = 60,           /* variable_object  */
  YYSYMBOL_var_object_file = 61,           /* var_object_file  */
  YYSYMBOL_var_object_cap = 62,            /* var_object_cap  */
  YYSYMBOL_var_object_net = 63,            /* var_object_net  */
  YYSYMBOL_var_object_list = 64,           /* var_object_list  */
  YYSYMBOL_domain_label = 65,              /* domain_label  */
  YYSYMBOL_66_1 = 66,                      /* $@1  */
  YYSYMBOL_domain_user_list = 67,          /* domain_user_list  */
  YYSYMBOL_role_label = 68,                /* role_label  */
  YYSYMBOL_role_type = 69,                 /* role_type  */
  YYSYMBOL_subject_label = 70,             /* subject_label  */
  YYSYMBOL_nested_label = 71,              /* nested_label  */
  YYSYMBOL_nested_subjs = 72,              /* nested_subjs  */
  YYSYMBOL_user_allow_ids = 73,            /* user_allow_ids  */
  YYSYMBOL_user_allow_label = 74,          /* user_allow_label  */
  YYSYMBOL_user_deny_ids = 75,             /* user_deny_ids  */
  YYSYMBOL_user_deny_label = 76,           /* user_deny_label  */
  YYSYMBOL_group_allow_ids = 77,           /* group_allow_ids  */
  YYSYMBOL_group_allow_label = 78,         /* group_allow_label  */
  YYSYMBOL_group_deny_ids = 79,            /* group_deny_ids  */
  YYSYMBOL_group_deny_label = 80,          /* group_deny_label  */
  YYSYMBOL_object_file_label = 81,         /* object_file_label  */
  YYSYMBOL_object_cap_label = 82,          /* object_cap_label  */
  YYSYMBOL_object_paxflag_label = 83,      /* object_paxflag_label  */
  YYSYMBOL_object_res_label = 84,          /* object_res_label  */
  YYSYMBOL_subj_mode = 85,                 /* subj_mode  */
  YYSYMBOL_obj_mode = 86,                  /* obj_mode  */
  YYSYMBOL_invert_socket = 87,             /* invert_socket  */
  YYSYMBOL_role_transitions = 88,          /* role_transitions  */
  YYSYMBOL_role_names = 89,                /* role_names  */
  YYSYMBOL_role_umask = 90,                /* role_umask  */
  YYSYMBOL_role_allow_ip = 91,             /* role_allow_ip  */
  YYSYMBOL_object_connect_ip_label = 92,   /* object_connect_ip_label  */
  YYSYMBOL_object_sock_allow_family = 93,  /* object_sock_allow_family  */
  YYSYMBOL_sock_families = 94,             /* sock_families  */
  YYSYMBOL_object_ip_override_label = 95,  /* object_ip_override_label  */
  YYSYMBOL_object_bind_ip_label = 96,      /* object_bind_ip_label  */
  YYSYMBOL_ip_netmask = 97,                /* ip_netmask  */
  YYSYMBOL_ip_ports = 98,                  /* ip_ports  */
  YYSYMBOL_ip_typeproto = 99               /* ip_typeproto  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  78
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   173

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  55
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  45
/* YYNRULES -- Number of rules.  */
#define YYNRULES  108
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  179

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   300


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    46,     2,
      49,    50,     2,     2,     2,    48,     2,    54,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    53,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    51,    47,    52,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,    59,    59,    60,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    90,    95,   103,   107,
     111,   115,   121,   132,   138,   144,   152,   159,   167,   171,
     178,   185,   192,   198,   199,   200,   201,   202,   203,   207,
     206,   213,   217,   223,   230,   231,   235,   250,   257,   263,
     275,   280,   285,   290,   295,   300,   305,   310,   315,   320,
     325,   330,   335,   341,   347,   354,   361,   371,   372,   377,
     378,   383,   384,   388,   393,   397,   403,   409,   413,   419,
     426,   434,   440,   445,   449,   455,   461,   468,   475,   482,
     489,   490,   495,   499,   503,   510,   514,   518,   522
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "ROLE", "ROLE_NAME",
  "SUBJECT", "SUBJ_NAME", "OBJ_NAME", "HOSTNAME", "RES_NAME",
  "RES_SOFTHARD", "CONNECT", "BIND", "IPTYPE", "IPPROTO", "CAP_NAME",
  "ROLE_ALLOW_IP", "PAX_NAME", "ROLE_TRANSITION", "VARIABLE", "DEFINE",
  "DEFINE_NAME", "DISABLED", "ID_NAME", "USER_TRANS_ALLOW",
  "GROUP_TRANS_ALLOW", "USER_TRANS_DENY", "GROUP_TRANS_DENY",
  "DOMAIN_TYPE", "DOMAIN", "INTERFACE", "IPOVERRIDE", "REPLACE", "REP_ARG",
  "AUDIT", "SOCKALLOWFAMILY", "SOCKFAMILY", "ROLE_UMASK", "OBJ_MODE",
  "SUBJ_MODE", "IPADDR", "IPNETMASK", "NOT", "IPPORT", "ROLE_TYPE",
  "UMASK", "'&'", "'|'", "'-'", "'('", "')'", "'{'", "'}'", "':'", "'/'",
  "$accept", "compiled_acl", "various_acls", "replace_rule",
  "variable_expression", "variable_object", "var_object_file",
  "var_object_cap", "var_object_net", "var_object_list", "domain_label",
  "$@1", "domain_user_list", "role_label", "role_type", "subject_label",
  "nested_label", "nested_subjs", "user_allow_ids", "user_allow_label",
  "user_deny_ids", "user_deny_label", "group_allow_ids",
  "group_allow_label", "group_deny_ids", "group_deny_label",
  "object_file_label", "object_cap_label", "object_paxflag_label",
  "object_res_label", "subj_mode", "obj_mode", "invert_socket",
  "role_transitions", "role_names", "role_umask", "role_allow_ip",
  "object_connect_ip_label", "object_sock_allow_family", "sock_families",
  "object_ip_override_label", "object_bind_ip_label", "ip_netmask",
  "ip_ports", "ip_typeproto", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-112)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      60,    17,    11,    -8,    16,    -4,    -3,    12,     4,  -112,
      24,  -112,    28,    30,    34,    36,    41,    64,    48,    37,
      54,    51,   -12,   103,  -112,  -112,    35,  -112,  -112,  -112,
    -112,  -112,  -112,  -112,  -112,  -112,  -112,  -112,  -112,  -112,
    -112,  -112,  -112,  -112,  -112,  -112,  -112,    61,   -10,  -112,
    -112,    97,  -112,  -112,     7,  -112,     1,  -112,    57,    57,
    -112,   109,    82,  -112,   113,  -112,   116,  -112,   120,  -112,
     121,   118,  -112,   114,  -112,   112,  -112,   -23,  -112,  -112,
     -12,   -12,   -12,  -112,  -112,  -112,   143,    13,  -112,  -112,
      57,    57,    57,    98,    57,   115,  -112,  -112,  -112,   130,
    -112,  -112,  -112,  -112,  -112,  -112,  -112,  -112,    26,   102,
    -112,  -112,   147,  -112,    98,    98,    98,   111,    80,    98,
    -112,    -8,    -2,     0,   123,  -112,  -112,  -112,    -1,   151,
    -112,    80,    80,    80,   110,  -112,  -112,    85,    80,  -112,
    -112,     8,  -112,     5,  -112,  -112,  -112,  -112,  -112,  -112,
     155,    85,    85,    85,   117,  -112,  -112,    85,    57,    57,
      57,    98,    57,  -112,  -112,    98,    98,    98,    80,    98,
      80,    80,    80,    85,    80,    85,    85,    85,    85
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       0,     0,     0,    79,     0,    81,    81,    74,     0,    75,
       0,    27,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     2,     5,    16,    15,     6,     4,
      10,    17,    11,    12,    13,    14,    18,    19,    20,    21,
       9,     8,     7,    22,    25,    24,    23,    54,    77,    80,
      72,     0,    91,    82,     0,    99,     0,    73,   100,   100,
      84,    83,     0,    60,    62,    66,    68,    63,    65,    69,
      71,     0,    95,     0,    93,    92,    86,     0,     1,     3,
       0,     0,     0,    55,    53,    78,     0,    77,    56,    76,
     100,   100,   100,   102,   100,     0,    88,    87,    85,     0,
      61,    67,    64,    70,    49,    26,    94,    31,    29,    28,
      30,    58,     0,    57,   102,   102,   102,     0,     0,   102,
     101,    79,    81,    81,    35,    43,    45,    44,     0,     0,
      59,     0,     0,     0,   103,   106,   105,    98,     0,    33,
      38,     0,    42,     0,    34,    32,    46,    48,    47,    51,
      50,    90,    89,    97,     0,   108,   107,    96,   100,   100,
     100,   102,   100,    52,   104,   102,   102,   102,     0,   102,
       0,     0,     0,    41,     0,    37,    36,    40,    39
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -112,  -112,   139,  -112,   -20,  -112,    38,    40,    42,  -112,
    -112,  -112,  -112,  -112,  -112,  -112,  -112,  -112,  -112,  -112,
    -112,  -112,  -112,  -112,  -112,  -112,  -112,  -112,  -112,  -112,
      84,    52,    -6,  -112,  -112,  -112,  -112,  -112,  -112,  -112,
    -112,  -112,   -58,  -111,    -7
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_uint8 yydefgoto[] =
{
       0,    23,    24,    25,    26,    27,   125,   126,   127,   128,
      28,   129,   150,    29,    84,    30,    31,    87,    64,    32,
      68,    33,    66,    34,    70,    35,    36,    37,    38,    39,
      88,    50,    54,    40,    61,    41,    42,    43,    44,    75,
      45,    46,    96,   118,   137
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
      56,    97,    77,   131,   132,   133,   121,    11,   138,    92,
     122,   123,    58,   160,   124,    90,   158,    48,    52,    55,
     140,    47,   142,    80,    81,    82,    51,   107,    60,    85,
      49,    93,   114,   115,   116,   161,   119,    22,    53,    53,
      53,    94,    53,    86,    59,   162,    57,    91,   159,    62,
     168,   145,    85,    63,   170,   171,   172,    65,   174,    67,
     108,   109,   110,     1,    69,     2,   112,     3,    71,     4,
      73,     5,     6,    81,    82,     7,     8,     9,    10,    11,
      12,    80,    81,    82,    13,    14,    15,    16,    72,    17,
      74,    18,    19,   135,   136,    20,    76,    21,   155,   156,
     165,   166,   167,    78,   169,    83,     1,    89,     2,    22,
       3,    95,     4,    98,     5,     6,   141,   143,     7,     8,
       9,    10,    11,    12,   151,   152,   153,    13,    14,    15,
      16,   157,    17,    99,    18,    19,   100,   121,    20,   101,
      21,   122,   123,   102,   103,   124,   104,   105,   106,   111,
      82,   117,    22,   130,   134,   149,   120,   144,   154,   163,
     164,   173,    79,   175,   176,   177,   146,   178,   147,     0,
     148,   113,     0,   139
};

static const yytype_int16 yycheck[] =
{
       6,    59,    22,   114,   115,   116,     7,    19,   119,     8,
      11,    12,     8,     8,    15,     8,     8,     6,    22,    22,
      22,     4,    22,    46,    47,    48,    10,    50,     4,    39,
      38,    30,    90,    91,    92,    30,    94,    49,    42,    42,
      42,    40,    42,    53,    40,    40,    34,    40,    40,    21,
     161,    52,    39,    23,   165,   166,   167,    23,   169,    23,
      80,    81,    82,     3,    23,     5,    53,     7,     4,     9,
      33,    11,    12,    47,    48,    15,    16,    17,    18,    19,
      20,    46,    47,    48,    24,    25,    26,    27,    40,    29,
      36,    31,    32,    13,    14,    35,    45,    37,    13,    14,
     158,   159,   160,     0,   162,    44,     3,    10,     5,    49,
       7,    54,     9,     4,    11,    12,   122,   123,    15,    16,
      17,    18,    19,    20,   131,   132,   133,    24,    25,    26,
      27,   138,    29,    51,    31,    32,    23,     7,    35,    23,
      37,    11,    12,    23,    23,    15,    28,    33,    36,     6,
      48,    53,    49,     6,    43,     4,    41,    34,    48,     4,
      43,   168,    23,   170,   171,   172,   128,   174,   128,    -1,
     128,    87,    -1,   121
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,     3,     5,     7,     9,    11,    12,    15,    16,    17,
      18,    19,    20,    24,    25,    26,    27,    29,    31,    32,
      35,    37,    49,    56,    57,    58,    59,    60,    65,    68,
      70,    71,    74,    76,    78,    80,    81,    82,    83,    84,
      88,    90,    91,    92,    93,    95,    96,     4,     6,    38,
      86,    10,    22,    42,    87,    22,    87,    34,     8,    40,
       4,    89,    21,    23,    73,    23,    77,    23,    75,    23,
      79,     4,    40,    33,    36,    94,    45,    59,     0,    57,
      46,    47,    48,    44,    69,    39,    53,    72,    85,    10,
       8,    40,     8,    30,    40,    54,    97,    97,     4,    51,
      23,    23,    23,    23,    28,    33,    36,    50,    59,    59,
      59,     6,    53,    85,    97,    97,    97,    53,    98,    97,
      41,     7,    11,    12,    15,    61,    62,    63,    64,    66,
       6,    98,    98,    98,    43,    13,    14,    99,    98,    86,
      22,    87,    22,    87,    34,    52,    61,    62,    63,     4,
      67,    99,    99,    99,    48,    13,    14,    99,     8,    40,
       8,    30,    40,     4,    43,    97,    97,    97,    98,    97,
      98,    98,    98,    99,    98,    99,    99,    99,    99
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    55,    56,    56,    57,    57,    57,    57,    57,    57,
      57,    57,    57,    57,    57,    57,    57,    57,    57,    57,
      57,    57,    57,    57,    57,    57,    58,    59,    59,    59,
      59,    59,    60,    61,    62,    62,    63,    63,    63,    63,
      63,    63,    63,    64,    64,    64,    64,    64,    64,    66,
      65,    67,    67,    68,    69,    69,    70,    71,    72,    72,
      73,    73,    74,    75,    75,    76,    77,    77,    78,    79,
      79,    80,    81,    82,    82,    83,    84,    85,    85,    86,
      86,    87,    87,    88,    89,    89,    90,    91,    91,    92,
      92,    92,    93,    94,    94,    95,    96,    96,    96,    96,
      97,    97,    98,    98,    98,    99,    99,    99,    99
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     1,     3,     3,
       3,     3,     5,     2,     2,     1,     6,     6,     2,     6,
       6,     5,     2,     1,     1,     1,     2,     2,     2,     0,
       5,     1,     2,     3,     0,     1,     3,     4,     2,     3,
       1,     2,     2,     1,     2,     2,     1,     2,     2,     1,
       2,     2,     2,     2,     1,     1,     3,     0,     1,     0,
       1,     0,     1,     2,     1,     2,     2,     3,     3,     6,
       6,     2,     2,     1,     2,     2,     6,     6,     5,     2,
       0,     2,     0,     2,     4,     1,     1,     2,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 16: /* various_acls: variable_expression  */
#line 76 "./gradm.y"
                                {
					interpret_variable((yyvsp[0].var));
				}
#line 1333 "gradm.tab.c"
    break;

  case 26: /* replace_rule: REPLACE REP_ARG REP_ARG  */
#line 91 "./gradm.y"
                                {
					add_replace_string((yyvsp[-1].string), (yyvsp[0].string));
				}
#line 1341 "gradm.tab.c"
    break;

  case 27: /* variable_expression: VARIABLE  */
#line 96 "./gradm.y"
                                {
					(yyval.var) = sym_retrieve((yyvsp[0].string));
					if (!(yyval.var)) {
						fprintf(stderr, "Variable \"%s\" not defined on line %lu of %s.\n", (yyvsp[0].string), lineno, current_acl_file);
						exit(EXIT_FAILURE);
					}
				}
#line 1353 "gradm.tab.c"
    break;

  case 28: /* variable_expression: variable_expression '|' variable_expression  */
#line 104 "./gradm.y"
                                {
					(yyval.var) = union_objects((yyvsp[-2].var), (yyvsp[0].var));
				}
#line 1361 "gradm.tab.c"
    break;

  case 29: /* variable_expression: variable_expression '&' variable_expression  */
#line 108 "./gradm.y"
                                {
					(yyval.var) = intersect_objects((yyvsp[-2].var), (yyvsp[0].var));
				}
#line 1369 "gradm.tab.c"
    break;

  case 30: /* variable_expression: variable_expression '-' variable_expression  */
#line 112 "./gradm.y"
                                {
					(yyval.var) = differentiate_objects((yyvsp[-2].var), (yyvsp[0].var));
				}
#line 1377 "gradm.tab.c"
    break;

  case 31: /* variable_expression: '(' variable_expression ')'  */
#line 116 "./gradm.y"
                                {
					(yyval.var) = (yyvsp[-1].var);
				}
#line 1385 "gradm.tab.c"
    break;

  case 32: /* variable_object: DEFINE DEFINE_NAME '{' var_object_list '}'  */
#line 122 "./gradm.y"
                                {
				  if (sym_retrieve((yyvsp[-3].string))) {
					fprintf(stderr, "Duplicate variable \"%s\" defined on line %lu of %s.\n", (yyvsp[-3].string), lineno, current_acl_file);
					exit(EXIT_FAILURE);
				  }
				  sym_store((yyvsp[-3].string), var_obj);
				  var_obj = NULL;
				}
#line 1398 "gradm.tab.c"
    break;

  case 33: /* var_object_file: OBJ_NAME obj_mode  */
#line 133 "./gradm.y"
                                {
				  add_file_var_object(&var_obj, (yyvsp[-1].string), (yyvsp[0].num));
				}
#line 1406 "gradm.tab.c"
    break;

  case 34: /* var_object_cap: CAP_NAME AUDIT  */
#line 139 "./gradm.y"
                                {
                                add_cap_var_object(&var_obj, (yyvsp[-1].string), (yyvsp[0].string));
                                free((yyvsp[-1].string));
                                free((yyvsp[0].string));
                               }
#line 1416 "gradm.tab.c"
    break;

  case 35: /* var_object_cap: CAP_NAME  */
#line 145 "./gradm.y"
                               {
                                add_cap_var_object(&var_obj, (yyvsp[0].string), NULL);
				 free((yyvsp[0].string));
				}
#line 1425 "gradm.tab.c"
    break;

  case 36: /* var_object_net: CONNECT invert_socket IPADDR ip_netmask ip_ports ip_typeproto  */
#line 153 "./gradm.y"
                                {
				 ip.addr = (yyvsp[-3].num);
				 ip.netmask = (yyvsp[-2].num);
				 add_net_var_object(&var_obj, &ip, GR_IP_CONNECT | (yyvsp[-4].num), NULL);
				 memset(&ip, 0, sizeof(ip));
				}
#line 1436 "gradm.tab.c"
    break;

  case 37: /* var_object_net: CONNECT invert_socket HOSTNAME ip_netmask ip_ports ip_typeproto  */
#line 160 "./gradm.y"
                                {
				 ip.netmask = (yyvsp[-2].num);
				 add_net_var_object(&var_obj, &ip, GR_IP_CONNECT | (yyvsp[-4].num), (yyvsp[-3].string));
				 memset(&ip, 0, sizeof(ip));
				 free((yyvsp[-3].string));
				}
#line 1447 "gradm.tab.c"
    break;

  case 38: /* var_object_net: CONNECT DISABLED  */
#line 168 "./gradm.y"
                                {
				 add_net_var_object(&var_obj, &ip, GR_IP_CONNECT, NULL);
				}
#line 1455 "gradm.tab.c"
    break;

  case 39: /* var_object_net: BIND invert_socket IPADDR ip_netmask ip_ports ip_typeproto  */
#line 172 "./gradm.y"
                                {
				 ip.addr = (yyvsp[-3].num);
				 ip.netmask = (yyvsp[-2].num);
				 add_net_var_object(&var_obj, &ip, GR_IP_BIND | (yyvsp[-4].num), NULL);
				 memset(&ip, 0, sizeof(ip));
				}
#line 1466 "gradm.tab.c"
    break;

  case 40: /* var_object_net: BIND invert_socket HOSTNAME ip_netmask ip_ports ip_typeproto  */
#line 179 "./gradm.y"
                                {
				 ip.netmask = (yyvsp[-2].num);
				 add_net_var_object(&var_obj, &ip, GR_IP_BIND | (yyvsp[-4].num), (yyvsp[-3].string));
				 memset(&ip, 0, sizeof(ip));
				 free((yyvsp[-3].string));
				}
#line 1477 "gradm.tab.c"
    break;

  case 41: /* var_object_net: BIND invert_socket INTERFACE ip_ports ip_typeproto  */
#line 186 "./gradm.y"
                                {
				 ip.iface = (yyvsp[-2].string);
				 add_net_var_object(&var_obj, &ip, GR_IP_BIND | (yyvsp[-3].num), NULL);
				 memset(&ip, 0, sizeof(ip));
				}
#line 1487 "gradm.tab.c"
    break;

  case 42: /* var_object_net: BIND DISABLED  */
#line 193 "./gradm.y"
                                {
				 add_net_var_object(&var_obj, &ip, GR_IP_BIND, NULL);
				}
#line 1495 "gradm.tab.c"
    break;

  case 49: /* $@1: %empty  */
#line 207 "./gradm.y"
                                {
				 add_role_acl(&current_role, (yyvsp[-1].string), GR_ROLE_DOMAIN | role_mode_conv((yyvsp[0].string)), 1);
				}
#line 1503 "gradm.tab.c"
    break;

  case 51: /* domain_user_list: ROLE_NAME  */
#line 214 "./gradm.y"
                                {
					add_domain_child(current_role, (yyvsp[0].string));
				}
#line 1511 "gradm.tab.c"
    break;

  case 52: /* domain_user_list: domain_user_list ROLE_NAME  */
#line 218 "./gradm.y"
                                {
					add_domain_child(current_role, (yyvsp[0].string));
				}
#line 1519 "gradm.tab.c"
    break;

  case 53: /* role_label: ROLE ROLE_NAME role_type  */
#line 224 "./gradm.y"
                                {
				 add_role_acl(&current_role, (yyvsp[-1].string), (yyvsp[0].shortnum), 0);
				}
#line 1527 "gradm.tab.c"
    break;

  case 54: /* role_type: %empty  */
#line 230 "./gradm.y"
                                { (yyval.shortnum) = role_mode_conv(""); }
#line 1533 "gradm.tab.c"
    break;

  case 55: /* role_type: ROLE_TYPE  */
#line 232 "./gradm.y"
                                { (yyval.shortnum) = (yyvsp[0].shortnum); }
#line 1539 "gradm.tab.c"
    break;

  case 56: /* subject_label: SUBJECT SUBJ_NAME subj_mode  */
#line 236 "./gradm.y"
                                {
				 if (current_role && current_role->roletype & GR_ROLE_LEARN) {
					fprintf(stderr, "Error on line %lu of %s.\n"
							"Subjects are not allowed for a role with learning enabled, as "
							"they are generated by the learning mode.\n"
							"The RBAC system will not load until you correct this error.\n\n",
							lineno, current_acl_file);
					exit(EXIT_FAILURE);
				 }

				 add_proc_subject_acl(current_role, (yyvsp[-1].string), (yyvsp[0].num), 0);
				}
#line 1556 "gradm.tab.c"
    break;

  case 57: /* nested_label: SUBJECT SUBJ_NAME nested_subjs subj_mode  */
#line 251 "./gradm.y"
                                {
					add_proc_nested_acl(current_role, (yyvsp[-2].string), (const char * const *)nested, current_nest_depth, (yyvsp[0].num));
					current_nest_depth = 0;
				}
#line 1565 "gradm.tab.c"
    break;

  case 58: /* nested_subjs: ':' SUBJ_NAME  */
#line 258 "./gradm.y"
                                {
					nested[current_nest_depth] = (yyvsp[0].string);
					current_nest_depth++;
				}
#line 1574 "gradm.tab.c"
    break;

  case 59: /* nested_subjs: nested_subjs ':' SUBJ_NAME  */
#line 264 "./gradm.y"
                                {
					if (current_nest_depth >= MAX_NEST_DEPTH) {
						fprintf(stderr, "Nesting too deep (over %d) on line %lu of %s.\n", MAX_NEST_DEPTH,
								lineno, current_acl_file);
						exit(EXIT_FAILURE);
					}
					nested[current_nest_depth] = (yyvsp[0].string);
					current_nest_depth++;
				}
#line 1588 "gradm.tab.c"
    break;

  case 60: /* user_allow_ids: ID_NAME  */
#line 276 "./gradm.y"
                                {
					add_id_transition(current_subject, (yyvsp[0].string), GR_ID_USER, GR_ID_ALLOW);
				}
#line 1596 "gradm.tab.c"
    break;

  case 61: /* user_allow_ids: user_allow_ids ID_NAME  */
#line 281 "./gradm.y"
                                {
					add_id_transition(current_subject, (yyvsp[0].string), GR_ID_USER, GR_ID_ALLOW);
				}
#line 1604 "gradm.tab.c"
    break;

  case 62: /* user_allow_label: USER_TRANS_ALLOW user_allow_ids  */
#line 286 "./gradm.y"
                                {
				}
#line 1611 "gradm.tab.c"
    break;

  case 63: /* user_deny_ids: ID_NAME  */
#line 291 "./gradm.y"
                                {
					add_id_transition(current_subject, (yyvsp[0].string), GR_ID_USER, GR_ID_DENY);
				}
#line 1619 "gradm.tab.c"
    break;

  case 64: /* user_deny_ids: user_deny_ids ID_NAME  */
#line 296 "./gradm.y"
                                {
					add_id_transition(current_subject, (yyvsp[0].string), GR_ID_USER, GR_ID_DENY);
				}
#line 1627 "gradm.tab.c"
    break;

  case 65: /* user_deny_label: USER_TRANS_DENY user_deny_ids  */
#line 301 "./gradm.y"
                                {
				}
#line 1634 "gradm.tab.c"
    break;

  case 66: /* group_allow_ids: ID_NAME  */
#line 306 "./gradm.y"
                                {
					add_id_transition(current_subject, (yyvsp[0].string), GR_ID_GROUP, GR_ID_ALLOW);
				}
#line 1642 "gradm.tab.c"
    break;

  case 67: /* group_allow_ids: group_allow_ids ID_NAME  */
#line 311 "./gradm.y"
                                {
					add_id_transition(current_subject, (yyvsp[0].string), GR_ID_GROUP, GR_ID_ALLOW);
				}
#line 1650 "gradm.tab.c"
    break;

  case 68: /* group_allow_label: GROUP_TRANS_ALLOW group_allow_ids  */
#line 316 "./gradm.y"
                                {
				}
#line 1657 "gradm.tab.c"
    break;

  case 69: /* group_deny_ids: ID_NAME  */
#line 321 "./gradm.y"
                                {
					add_id_transition(current_subject, (yyvsp[0].string), GR_ID_GROUP, GR_ID_DENY);
				}
#line 1665 "gradm.tab.c"
    break;

  case 70: /* group_deny_ids: group_deny_ids ID_NAME  */
#line 326 "./gradm.y"
                                {
					add_id_transition(current_subject, (yyvsp[0].string), GR_ID_GROUP, GR_ID_DENY);
				}
#line 1673 "gradm.tab.c"
    break;

  case 71: /* group_deny_label: GROUP_TRANS_DENY group_deny_ids  */
#line 331 "./gradm.y"
                                {
				}
#line 1680 "gradm.tab.c"
    break;

  case 72: /* object_file_label: OBJ_NAME obj_mode  */
#line 336 "./gradm.y"
                                {
				 add_proc_object_acl(current_subject, (yyvsp[-1].string), (yyvsp[0].num), GR_FEXIST);
				}
#line 1688 "gradm.tab.c"
    break;

  case 73: /* object_cap_label: CAP_NAME AUDIT  */
#line 342 "./gradm.y"
                                {
                                add_cap_acl(current_subject, (yyvsp[-1].string), (yyvsp[0].string));
                                free((yyvsp[-1].string));
                                free((yyvsp[0].string));
                               }
#line 1698 "gradm.tab.c"
    break;

  case 74: /* object_cap_label: CAP_NAME  */
#line 348 "./gradm.y"
                               {
                                add_cap_acl(current_subject, (yyvsp[0].string), NULL);
				 free((yyvsp[0].string));
				}
#line 1707 "gradm.tab.c"
    break;

  case 75: /* object_paxflag_label: PAX_NAME  */
#line 355 "./gradm.y"
                                {
				 add_paxflag_acl(current_subject, (yyvsp[0].string));
				 free((yyvsp[0].string));
				}
#line 1716 "gradm.tab.c"
    break;

  case 76: /* object_res_label: RES_NAME RES_SOFTHARD RES_SOFTHARD  */
#line 362 "./gradm.y"
                                {
				 add_res_acl(current_subject, (yyvsp[-2].string), (yyvsp[-1].string), (yyvsp[0].string));
				 free((yyvsp[-2].string));
				 free((yyvsp[-1].string));
				 free((yyvsp[0].string));
				}
#line 1727 "gradm.tab.c"
    break;

  case 77: /* subj_mode: %empty  */
#line 371 "./gradm.y"
                                { (yyval.num) = proc_subject_mode_conv(""); }
#line 1733 "gradm.tab.c"
    break;

  case 78: /* subj_mode: SUBJ_MODE  */
#line 373 "./gradm.y"
                                { (yyval.num) = (yyvsp[0].num); }
#line 1739 "gradm.tab.c"
    break;

  case 79: /* obj_mode: %empty  */
#line 377 "./gradm.y"
                                { (yyval.num) = proc_object_mode_conv(""); }
#line 1745 "gradm.tab.c"
    break;

  case 80: /* obj_mode: OBJ_MODE  */
#line 379 "./gradm.y"
                                { (yyval.num) = (yyvsp[0].num); }
#line 1751 "gradm.tab.c"
    break;

  case 81: /* invert_socket: %empty  */
#line 383 "./gradm.y"
                { (yyval.num) = 0; }
#line 1757 "gradm.tab.c"
    break;

  case 82: /* invert_socket: NOT  */
#line 385 "./gradm.y"
                { (yyval.num) = GR_IP_INVERT; }
#line 1763 "gradm.tab.c"
    break;

  case 83: /* role_transitions: ROLE_TRANSITION role_names  */
#line 389 "./gradm.y"
                                {
				}
#line 1770 "gradm.tab.c"
    break;

  case 84: /* role_names: ROLE_NAME  */
#line 394 "./gradm.y"
                                {
					add_role_transition(current_role, (yyvsp[0].string));
				}
#line 1778 "gradm.tab.c"
    break;

  case 85: /* role_names: role_names ROLE_NAME  */
#line 398 "./gradm.y"
                                {
					add_role_transition(current_role, (yyvsp[0].string));
				}
#line 1786 "gradm.tab.c"
    break;

  case 86: /* role_umask: ROLE_UMASK UMASK  */
#line 404 "./gradm.y"
                                {
					set_role_umask(current_role, (yyvsp[0].shortnum));
				}
#line 1794 "gradm.tab.c"
    break;

  case 87: /* role_allow_ip: ROLE_ALLOW_IP IPADDR ip_netmask  */
#line 410 "./gradm.y"
                                {
					add_role_allowed_ip(current_role, (yyvsp[-1].num), (yyvsp[0].num));
				}
#line 1802 "gradm.tab.c"
    break;

  case 88: /* role_allow_ip: ROLE_ALLOW_IP HOSTNAME ip_netmask  */
#line 414 "./gradm.y"
                                {
					add_role_allowed_host(current_role, (yyvsp[-1].string), (yyvsp[0].num));
				}
#line 1810 "gradm.tab.c"
    break;

  case 89: /* object_connect_ip_label: CONNECT invert_socket IPADDR ip_netmask ip_ports ip_typeproto  */
#line 420 "./gradm.y"
                                {
				 ip.addr = (yyvsp[-3].num);
				 ip.netmask = (yyvsp[-2].num);
				 add_ip_acl(current_subject, GR_IP_CONNECT | (yyvsp[-4].num), &ip);
				 memset(&ip, 0, sizeof(ip));
				}
#line 1821 "gradm.tab.c"
    break;

  case 90: /* object_connect_ip_label: CONNECT invert_socket HOSTNAME ip_netmask ip_ports ip_typeproto  */
#line 427 "./gradm.y"
                                {
				 ip.netmask = (yyvsp[-2].num);
				 add_host_acl(current_subject, GR_IP_CONNECT | (yyvsp[-4].num), (yyvsp[-3].string), &ip);
				 memset(&ip, 0, sizeof(ip));
				 free((yyvsp[-3].string));
				}
#line 1832 "gradm.tab.c"
    break;

  case 91: /* object_connect_ip_label: CONNECT DISABLED  */
#line 435 "./gradm.y"
                                {
				 add_ip_acl(current_subject, GR_IP_CONNECT, &ip);
				}
#line 1840 "gradm.tab.c"
    break;

  case 92: /* object_sock_allow_family: SOCKALLOWFAMILY sock_families  */
#line 441 "./gradm.y"
                                {
				}
#line 1847 "gradm.tab.c"
    break;

  case 93: /* sock_families: SOCKFAMILY  */
#line 446 "./gradm.y"
                                {
				 add_sock_family(current_subject, (yyvsp[0].string));
				}
#line 1855 "gradm.tab.c"
    break;

  case 94: /* sock_families: sock_families SOCKFAMILY  */
#line 450 "./gradm.y"
                                {
				 add_sock_family(current_subject, (yyvsp[0].string));
				}
#line 1863 "gradm.tab.c"
    break;

  case 95: /* object_ip_override_label: IPOVERRIDE IPADDR  */
#line 456 "./gradm.y"
                                {
				 current_subject->inaddr_any_override = (yyvsp[0].num);
				}
#line 1871 "gradm.tab.c"
    break;

  case 96: /* object_bind_ip_label: BIND invert_socket IPADDR ip_netmask ip_ports ip_typeproto  */
#line 462 "./gradm.y"
                                {
				 ip.addr = (yyvsp[-3].num);
				 ip.netmask = (yyvsp[-2].num);
				 add_ip_acl(current_subject, GR_IP_BIND | (yyvsp[-4].num), &ip);
				 memset(&ip, 0, sizeof(ip));
				}
#line 1882 "gradm.tab.c"
    break;

  case 97: /* object_bind_ip_label: BIND invert_socket HOSTNAME ip_netmask ip_ports ip_typeproto  */
#line 469 "./gradm.y"
                                {
				 ip.netmask = (yyvsp[-2].num);
				 add_host_acl(current_subject, GR_IP_BIND | (yyvsp[-4].num), (yyvsp[-3].string), &ip);
				 memset(&ip, 0, sizeof(ip));
				 free((yyvsp[-3].string));
				}
#line 1893 "gradm.tab.c"
    break;

  case 98: /* object_bind_ip_label: BIND invert_socket INTERFACE ip_ports ip_typeproto  */
#line 476 "./gradm.y"
                                {
				 ip.iface = (yyvsp[-2].string);
				 add_ip_acl(current_subject, GR_IP_BIND | (yyvsp[-3].num), &ip);
				 memset(&ip, 0, sizeof(ip));
				}
#line 1903 "gradm.tab.c"
    break;

  case 99: /* object_bind_ip_label: BIND DISABLED  */
#line 483 "./gradm.y"
                                {
				 add_ip_acl(current_subject, GR_IP_BIND, &ip);
				}
#line 1911 "gradm.tab.c"
    break;

  case 100: /* ip_netmask: %empty  */
#line 489 "./gradm.y"
                                { (yyval.num) = 0xffffffff; }
#line 1917 "gradm.tab.c"
    break;

  case 101: /* ip_netmask: '/' IPNETMASK  */
#line 491 "./gradm.y"
                                { (yyval.num) = (yyvsp[0].num); }
#line 1923 "gradm.tab.c"
    break;

  case 102: /* ip_ports: %empty  */
#line 495 "./gradm.y"
                                {
				 ip.low = 0;
				 ip.high = 65535;
				}
#line 1932 "gradm.tab.c"
    break;

  case 103: /* ip_ports: ':' IPPORT  */
#line 500 "./gradm.y"
                                {
				 ip.low = ip.high = (yyvsp[0].shortnum);
				}
#line 1940 "gradm.tab.c"
    break;

  case 104: /* ip_ports: ':' IPPORT '-' IPPORT  */
#line 504 "./gradm.y"
                                {
				 ip.low = (yyvsp[-2].shortnum);
				 ip.high = (yyvsp[0].shortnum);
				}
#line 1949 "gradm.tab.c"
    break;

  case 105: /* ip_typeproto: IPPROTO  */
#line 511 "./gradm.y"
                                { conv_name_to_type(&ip, (yyvsp[0].string));
				  free((yyvsp[0].string));
				}
#line 1957 "gradm.tab.c"
    break;

  case 106: /* ip_typeproto: IPTYPE  */
#line 515 "./gradm.y"
                                { conv_name_to_type(&ip, (yyvsp[0].string));
				  free((yyvsp[0].string));
				}
#line 1965 "gradm.tab.c"
    break;

  case 107: /* ip_typeproto: ip_typeproto IPPROTO  */
#line 519 "./gradm.y"
                                { conv_name_to_type(&ip, (yyvsp[0].string));
				  free((yyvsp[0].string));
				}
#line 1973 "gradm.tab.c"
    break;

  case 108: /* ip_typeproto: ip_typeproto IPTYPE  */
#line 523 "./gradm.y"
                                { conv_name_to_type(&ip, (yyvsp[0].string));
				  free((yyvsp[0].string));
				}
#line 1981 "gradm.tab.c"
    break;


#line 1985 "gradm.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

